backend/expense_report/urls.py
from django.urls import path

from .views import (
    ExpenseReportCreateView,
    ExpenseReportDetailView,
    ExpenseReportListView,
    ExpenseReportUpdateView,
    HelpView,
    IndexView,
    UserBankingInformationDetailView,
    UserBankingInformationListView,
    UserBankingInformationUpdateView,
)

urlpatterns = [
    path("", IndexView.as_view(), name="index"),
    path("help/", HelpView.as_view(), name="help"),
    path("ndf/", ExpenseReportListView.as_view(), name="expense-report-list"),
    path(
        "ndf/new/",
        ExpenseReportCreateView.as_view(),
        name="expense-report-create",
    ),
    path(
        "ndf/<int:pk>/",
        ExpenseReportDetailView.as_view(),
        name="expense-report-detail",
    ),
    path(
        "ndf/<int:pk>/edit/",
        ExpenseReportUpdateView.as_view(),
        name="expense-report-update",
    ),
    path(
        "user/banking-information/",
        UserBankingInformationListView.as_view(),
        name="user-banking-information-list",
    ),
    path(
        "user/banking-information/<int:pk>/",
        UserBankingInformationDetailView.as_view(),
        name="user-banking-information-detail",
    ),
    path(
        "user/banking-information/<int:pk>/edit/",
        UserBankingInformationUpdateView.as_view(),
        name="user-banking-information-update",
    ),
]

backend/ndf/urls.py
from django.urls import include, path
from django_utils.urls import default, drf

urlpatterns = (
    default.urlpatterns()
    + drf.urlpatterns(with_auth=True)
    + [
        path("", include("expense_report.urls")),
    ]
)

backend/expense_report/models.py
import auto_prefetch
from auditlog.models import AuditlogHistoryField
from auditlog.registry import auditlog
from django.conf import settings
from django.contrib.auth import get_user_model
from django.core.validators import FileExtensionValidator
from django.db import models
from django.db.models import Q, Sum
from django.db.models.signals import post_save
from django.dispatch import receiver
from django.template.loader import get_template
from django.urls import reverse
from django.utils import timezone
from django.utils.module_loading import import_string
from django_fsm import FSMField, transition
from localflavor.generic.countries.sepa import IBAN_SEPA_COUNTRIES
from localflavor.generic.models import BICField, IBANField
from model_utils.choices import Choices
from model_utils.fields import MonitorField
from model_utils.models import TimeStampedModel
from post_office import mail

from .tasks import expense_report_generate_document
from .validators import validate_is_pdf

User = get_user_model()


class ExpenseReport(auto_prefetch.Model, TimeStampedModel):
    history = AuditlogHistoryField()

    state = FSMField(default="draft")
    state_changed = MonitorField(monitor="state")

    created_by = auto_prefetch.ForeignKey(
        User,
        on_delete=models.SET_NULL,
        null=True,
        db_index=True,
        related_name="created_by",
    )
    modified_by = auto_prefetch.ForeignKey(
        User,
        on_delete=models.SET_NULL,
        null=True,
        db_index=True,
        related_name="last_modified_by",
    )
    submitted_at = models.DateTimeField(blank=True, null=True)

    # Values from https://gitlab.com/prologin/asso/documents/-/blob/main/note_de_frais/schema.json#L18
    APPROVER = Choices(
        ("PRESIDENCY", "Présidence"),
        ("SECRETARY", "Secrétariat"),
        ("TREASURY", "Trésorerie"),
    )
    approved_by = models.CharField(max_length=10, choices=APPROVER)

    # Values from https://gitlab.com/prologin/asso/documents/-/blob/main/note_de_frais/schema.json#L29
    EVENT = Choices(
        ("GCC", "GCC!"),
        ("ATELIER", "Atelier"),
        ("ER", "Épreuve régionale"),
        ("FINAL", "Finale Prologin"),
        ("OTHER", "Autre"),
    )
    event = models.CharField(max_length=10, choices=EVENT)
    event_description = models.TextField()

    description = models.TextField()

    document = models.FileField(
        storage=import_string(settings.PRIVATE_FILE_STORAGE),
        upload_to="expense_report/expense_reports/",
        validators=(
            FileExtensionValidator(allowed_extensions=("pdf",)),
            validate_is_pdf,
        ),
        null=True,
        blank=True,
    )
    document_id = models.CharField(
        max_length=32,
        unique=True,
        blank=True,
        null=True,
    )
    reason = models.TextField(blank=True)

    class Meta(auto_prefetch.Model.Meta):
        ordering = (
            "-submitted_at",
            "-created",
        )
        permissions = (
            ("manage_expensereport", "Can approve an expense report"),
        )

    def __str__(self):
        return f"{self.submitted_at.date() if self.submitted_at else self.created.date()} - {self.created_by} - {self.state} - {self.event}"

    def get_state_display(self):
        displays = {
            "draft": "Brouillon",
            "submitted": "Soumis",
            "approved": "Approuvée",
            "reimbursed": "Remboursée",
            "_closed": "Fermée",
        }
        return displays[self.state]

    def get_absolute_url(self):
        return reverse("expense-report-detail", kwargs={"pk": self.pk})

    def get_absolute_url_full(self):
        return f"{'https' if settings.SECURE_SSL_REDIRECT else 'http'}://{settings.DEFAULT_DOMAIN}{self.get_absolute_url()}"

    @property
    def amount(self):
        return float(self.entries.aggregate(Sum("amount"))["amount__sum"] or 0)

    def department_from_event(self):
        event_to_department = {
            "GCC": "gcc",
            "ATELIER": "ateliers",
            "ER": "concours",
            "FINAL": "concours",
            "OTHER": "FIXME",
        }
        return event_to_department.get(self.event, "FIXME")

    def accounting_entries(self):
        if (
            self.entries.filter(
                Q(account_source=None) | Q(account_dest=None)
            ).count()
            != 0
        ):
            return None

        context = {
            "object": self,
            "accounts_dest": self.entries.values("account_dest").annotate(
                amount=Sum("amount")
            ),
        }
        return get_template("accounting_entries.plain").render(context)

    @transition(field=state, source="draft", target="submitted")
    def submit(self):
        self.submitted_at = timezone.now()
        self.reason = ""

        mail.send(
            recipients=settings.EXPENSE_REPORTS_MANAGERS,
            subject="[NDF] Une nouvelle note de frais a été soumise.",
            message=get_template("mail/submitted.plain").render(
                {"object": self}
            ),
        )

    @transition(
        field=state,
        source="submitted",
        target="approved",
        permission="expense_report.manage_expensereport",
    )
    def approve(self, document_id):
        self.document_id = document_id
        self.reason = ""

        mail.send(
            recipients=self.created_by.email,
            subject="[NDF] Ta note de frais a été approuvée.",
            message=get_template("mail/approved.plain").render(
                {"object": self}
            ),
        )

        expense_report_generate_document.delay(self.pk)

    @transition(
        field=state,
        source="submitted",
        target="draft",
        permission="expense_report.manage_expensereport",
    )
    def reject(self, reason):
        self.reason = reason

        mail.send(
            recipients=self.created_by.email,
            subject="[NDF] Ta note de frais a été rejetée.",
            message=get_template("mail/rejected.plain").render(
                {"object": self}
            ),
        )

    @transition(
        field=state,
        source="approved",
        target="reimbursed",
        permission="expense_report.manage_expensereport",
    )
    def reimburse(self):
        self.reason = ""

        mail.send(
            recipients=self.created_by.email,
            subject="[NDF] Ta note de frais a été remboursée.",
            message=get_template("mail/reimbursed.plain").render(
                {"object": self}
            ),
        )

    @transition(
        field=state,
        source="reimbursed",
        target="_closed",
        permission="expense_report.manage_expensereport",
    )
    def close(self):
        self.reason = ""

    @transition(field=state, source="draft", target="*")
    def destroy(self):
        self.delete()

    def get_available_transitions(self, user=None):
        if not user:
            transitions = self.get_available_state_transitions()
        else:
            transitions = self.get_available_user_state_transitions(user)
        return [t.name for t in transitions]


class ExpenseReportEntry(auto_prefetch.Model):
    history = AuditlogHistoryField()

    expense_report = auto_prefetch.ForeignKey(
        ExpenseReport,
        on_delete=models.CASCADE,
        db_index=True,
        related_name="entries",
    )

    date = models.DateField()

    # Values from https://gitlab.com/prologin/asso/documents/-/blob/main/note_de_frais/schema.json#L73
    EXPENSE_TYPES = Choices(
        ("TRANSPORT", "Transport"),
        ("ACCOMODATION", "Hébergement"),
        ("MEAL", "Repas"),
        ("PURCHASE", "Achat"),
        ("OTHER", "Autre"),
    )
    expense_type = models.CharField(max_length=12, choices=EXPENSE_TYPES)

    description = models.TextField()

    amount = models.DecimalField(max_digits=7, decimal_places=2)

    proof = models.FileField(
        storage=import_string(settings.PRIVATE_FILE_STORAGE),
        upload_to="expense_report/expense_report_entry_proof/",
        validators=(
            FileExtensionValidator(allowed_extensions=("pdf",)),
            validate_is_pdf,
        ),
    )

    account_source = models.CharField(max_length=200, blank=True, null=True)
    account_dest = models.CharField(max_length=200, blank=True, null=True)

    class Meta(auto_prefetch.Model.Meta):
        ordering = ("date", "expense_type", "amount")

    def __str__(self):
        return f"{self.expense_report} - Entry - {self.date} - {self.expense_type} - {self.amount}"


class UserBankingInformation(auto_prefetch.Model):
    history = AuditlogHistoryField()

    user = auto_prefetch.OneToOneField(
        User,
        on_delete=models.CASCADE,
        related_name="banking_information",
        primary_key=True,
    )

    file = models.FileField(
        storage=import_string(settings.PRIVATE_FILE_STORAGE),
        upload_to="expense_report/banking_informations/",
        validators=(
            FileExtensionValidator(allowed_extensions=("pdf",)),
            validate_is_pdf,
        ),
        null=True,
    )

    iban = IBANField(include_countries=IBAN_SEPA_COUNTRIES, null=True)
    bic = BICField(null=True)

    validated = models.BooleanField(default=False)

    def __str__(self):
        return f"{self.user} - {self.iban} - {self.bic}"

    @property
    def is_complete(self):
        return self.file and self.iban and self.bic


@receiver(post_save, sender=User)
def create_user_banking_information(sender, instance, created, **kwargs):
    if created:
        bi = UserBankingInformation.objects.create(user=instance)
        bi.save()


auditlog.register(
    ExpenseReport,
    exclude_fields=["created", "modified"],
    serialize_data=True,
    serialize_auditlog_fields_only=True,
)
auditlog.register(
    ExpenseReportEntry,
    serialize_data=True,
    serialize_auditlog_fields_only=True,
)
auditlog.register(

backend/expense_report/forms.py
from django import forms
from django.forms.models import inlineformset_factory

from .models import ExpenseReport, ExpenseReportEntry, UserBankingInformation


class ClearableFileInput(forms.ClearableFileInput):
    template_name = "clearable_file_input.html"


class ExpenseReportForm(forms.ModelForm):
    class Meta:
        model = ExpenseReport
        fields = (
            "approved_by",
            "event",
            "event_description",
            "description",
        )
        labels = {
            "approved_by": "Approuvé par",
            "event": "Événement",
            "event_description": "Complément d'événement",
            "description": "Descriptif",
        }
        help_texts = {
            "approved_by": "Veuillez sélectionner le département ayant approuvé vos achats.",
            "event": "Veuillez sélectionner l'événement associé à cette note de frais.",
            "event_description": "Pour GCC! et les épreuves régionales, veuillez indiquer l'année, le mois et le lieu de l'événement. Pour la finale Prologin, indiquez l'année. Sinon, précisez.",
            "description": "Veuillez préciser le but de cette dépense.",
        }
        widgets = {
            "event_description": forms.Textarea(
                attrs={
                    "rows": 3,
                    "placeholder": "Pour GCC!, Ateliers et ER, veuillez indiquer l'année, le mois et le lieu de l'événement. Pour la finale Prologin, indiquez l'année. Sinon, précisez.",
                }
            ),
            "description": forms.Textarea(
                attrs={
                    "rows": 3,
                    "placeholder": "Veuillez préciser le but de cette dépense.",
                }
            ),
        }


class ExpenseReportEntryForm(forms.ModelForm):
    class Meta:
        model = ExpenseReportEntry
        fields = (
            "expense_report",
            "date",
            "expense_type",
            "description",
            "amount",
            "proof",
        )
        labels = {
            "date": "Date de l'achat",
            "expense_type": "Type",
            "description": "Description",
            "amount": "Montant",
            "proof": "Justificatif de paiement",
        }
        help_texts = {
            "date": "Cette date doit être la même que sur le justificatif associé.",
            "expense_type": "Veuillez choisir le type de cette dépense.",
            "description": "Veuillez décrire la dépense. S'il s'agit d'un repas, veuillez inclure le nombre de participants, le nombre d'organisateurs et la liste des organisateurs.",
            "amount": "Ce montant doit être le même que sur le justificatif associé, toutes taxes comprises (TTC).",
            "proof": "PDF uniquement. Doit être un justificatif comptable valable, à savoir une facture. Un ticket de carte bancaire n'est pas un justificatif. Si vous n'êtes pas en possession de justificatif, merci de vous référer à la page d'aide.",
        }
        widgets = {
            "date": forms.DateInput(format="%Y-%m-%d", attrs={"type": "date"}),
            "description": forms.Textarea(
                attrs={
                    "rows": 3,
                    "placeholder": "S'il s'agit d'un repas, veuillez inclure le nombre de participants, le nombre d'organisateurs et la liste des organisateurs.",
                }
            ),
            "proof": ClearableFileInput(
                attrs={"accept": ".pdf,application/pdf"}
            ),
        }


ExpenseReportEntryFormSet = inlineformset_factory(
    ExpenseReport,
    ExpenseReportEntry,
    form=ExpenseReportEntryForm,
    fields=("date", "expense_type", "description", "amount", "proof"),
    extra=1,
    can_delete=True,
)


class ExpenseReportEntryWithAccountingForm(ExpenseReportEntryForm):
    class Meta(ExpenseReportEntryForm.Meta):
        fields = ExpenseReportEntryForm.Meta.fields + (
            "account_dest",
            "account_source",
        )
        labels = {
            **ExpenseReportEntryForm.Meta.labels,
            "account_dest": "Compte destination",
            "account_source": "Compte source",
        }
        help_texts = {
            **ExpenseReportEntryForm.Meta.help_texts,
            "account_dest": "Généralement un compte de charges (6).",
            "account_source": "Généralement un compte de tiers (4).",
        }


ExpenseReportEntryWithAccountingFormSet = inlineformset_factory(
    ExpenseReport,
    ExpenseReportEntry,
    form=ExpenseReportEntryWithAccountingForm,
    fields=ExpenseReportEntryFormSet.form.Meta.fields
    + ("account_dest", "account_source"),
    extra=0,
    can_delete=False,
)


class UserBankingInformationForm(forms.ModelForm):
    class Meta:
        model = UserBankingInformation
        fields = ("file", "iban", "bic")
        labels = {
            "file": "RIB/IBAN au format PDF",
            "iban": "IBAN",
            "bic": "BIC",
        }
        widgets = {
            "file": ClearableFileInput(
                attrs={"accept": ".pdf,application/pdf"}
            ),
        }

    def save(self, commit=True):
        instance = super().save(commit=False)
        instance.validated = False
        if commit:
            instance.save()
        return instance


class UserBankingInformationWithValidationForm(forms.ModelForm):
    class Meta(UserBankingInformationForm.Meta):
        fields = UserBankingInformationForm.Meta.fields + ("validated",)

backend/expense_report/templates/base.html
{% load static %}

<!DOCTYPE html>
<html lang="en" data-theme='light'>
  <head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>NDF</title>
    <link rel="icon" type="image/png" href="{% static "favicon.ico " %}">
    <link rel="stylesheet" href="{% static "classless.css" %}">
    <link rel="stylesheet" href="{% static "style.css" %}">
    {% block head %}
    {% endblock %}
  </head>
  <body>
    <nav>
      <ul class="sticky">
        <li><a href="{% url "index" %}">NDF</a></li>
        <li><a href="{% url "expense-report-create" %}">Créer une note de frais</a></li>
        <li><a href="{% url "help" %}">Aide</a></li>

        <li class="float-right"><a href="{% url "user-banking-information-detail" request.user.banking_information.pk %}">{{ request.user.username }}</a></li>
        {% if perms.expense_report.manage_expense_report %}
        <li class="float-right"><a href="{% url "user-banking-information-list" %}">Tous les utilisateurs</a></li>
        <li class="float-right"><a href="{% url "expense-report-list" %}">Toutes les notes de frais</a></li>
        {% endif %}
      </ul>
    </nav>
    <main style="text-align: center;">
      {% if messages %}
        {% for message in messages %}
        <blockquote{% if message.tags %} class="{{ message.tags }}"{% endif %}>{{ message }}</blockquote>
        {% endfor %}
      {% endif %}

      <center style="display: inline-grid;">
        {% block content %}
        {% endblock %}
      </center>
    </main>
    {% block scripts %}
    {% endblock %}
  </body>
</html>

backend/expense_report/templates/clearable_file_input.html
{% load basename %}{% if widget.is_initial %}{{ widget.initial_text }}: <a href="{{ widget.value.url }}">{{ widget.value | basename }}</a>{% if not widget.required %}
<input type="checkbox" name="{{ widget.checkbox_name }}" id="{{ widget.checkbox_id }}"{% if widget.attrs.disabled %} disabled{% endif %}>
<label for="{{ widget.checkbox_id }}">{{ widget.clear_checkbox_label }}</label>{% endif %}<br>
{{ widget.input_text }}:{% endif %}
<input type="{{ widget.type }}" name="{{ widget.name }}"{% include "django/forms/widgets/attrs.html" %}>

backend/expense_report/templates/expense_report_detail.html
{% extends "base.html" %}
{% load transitions %}

{% block content %}
<h3>Ma note de frais</h3>

<form action="." method="POST">
<section style="text-align: right;">
  {% with available_transitions=object|get_available_transitions:request.user %}
    {% csrf_token %}
    <div>
    {% for transition in available_transitions %}
    <button type="submit" name="{{ transition }}">{{ transition | get_transition_display }}</button>
    {% endfor %}
    </div>
    <div style="display: inline-block;">
    <br />
    {% if "approve" in available_transitions and perms.expense_report.manage_expense_report %}
    <input type="text" name="document_id" id="id_document_id" placeholder="Si OK : ID NDF2042-000" value="{{ next_document_id }}" />
    {% endif %}
    {% if "reject" in available_transitions and perms.expense_report.manage_expense_report %}
    <textarea name="reason" cols="21" rows="3" id="id_reason" placeholder="Si rejetée : raison du rejet"></textarea>
    {% endif %}
    </div>
    {% if "submit" in available_transitions %}
    <blockquote class="info">
      En soumettant cette note de frais, le membre certifie que tous les
      éléments constituant ce document sont exacts.
    </blockquote>
    {% endif %}

  {% if object.state == "draft" and object.reason != "" %}
  <blockquote class="warn">
    La note de frais a été rejetée. Raison : {{ object.reason }}
  </blockquote>
  {% endif %}

  {% if "submit" in available_transitions or perms.expense_report.manage_expense_report %}
  {% if object.state != "_closed" %}
  <br />
  <a href="{% url "expense-report-update" object.pk %}"><button type="button">Éditer</button></a>
  {% endif %}
  {% endif %}
  {% endwith %}
</section>

<section>
  <table style="text-align: revert;">
    <legend>Informations</legend>
    <thead>
      <th>ID</th>
      <th>Status</th>
      <th>{% if object.submitted_at %}Soumis à{% else %}Créée à{% endif %}</th>
      <th>Créé par</th>
      <th>Événement</th>
      <th>Descriptif</th>
      <th>Approuvé par</th>
      <th>Montant</th>
      <th>Document</th>
    </thead>
    <tr>
      <td>{% if object.document_id %}{{ object.document_id }}{% endif %}</td>
      <td>{{ object.get_state_display }}</td>
      <td>{% if object.submitted_at %}{{ object.submitted_at.date }}{% else %}{{ object.created.date }}{% endif %}</td>
      <td><a href="{% url "user-banking-information-detail" object.created_by.banking_information.pk %}">{{ object.created_by }}</a></td>
      <td class="text-wrap">{{ object.get_event_display }} : {{ object.event_description }}</td>
      <td class="text-wrap">{{ object.description }}</td>
      <td>{{ object.get_approved_by_display }}</td>
      <td>{{ object.amount }} €</td>
      <td>
        {% if object.document %}
          <a href="{{ object.document.url }}" target="_blank">Télécharger</a>
        {% endif %}
        {% if object.state != "draft" and object.state != "submitted" %}
          <button type="submit" name="generate">Générer</button>
        {% endif %}
      </td>
    </tr>
  </table>
</section>

<section>
  <legend>Détail des achats</legend>
  <table style="text-align: revert;">
    <thead>
      <th>Date</th>
      <th>Type</th>
      <th>Descriptif</th>
      <th>Montant</th>
      <th>Justificatif</th>
      {% if object.state != "draft" and object.state != "submitted" %}
      <th>Compte destination</th>
      <th>Compte source</th>
      {% endif %}
    </thead>
    <tbody>
      {% for entry in object.entries.all %}
      <tr>
        <td>{{ entry.date }}</td>
        <td>{{ entry.get_expense_type_display }}</td>
        <td class="text-wrap">{{ entry.description }}</td>
        <td>{{ entry.amount }} €</td>
        <td><a href="{{ entry.proof.url }}" target="_blank">Télécharger</a></td>
        {% if object.state != "draft" and object.state != "submitted" %}
        <td>{{ entry.account_dest }}</td>
        <td>{{ entry.account_source }}</td>
        {% endif %}
      </tr>
      {% endfor %}
    </tbody>
  </table>
</section>

{% if object.state != "draft" and object.state != "submitted" and object.state != "rejected" %}
<section>
  <legend>Entrées comptables</legend>
  {% if not object.accounting_entries %}
  <p>
  Les comptes sources et destination n'ont pas tous été spécifiés pour cette
  note de frais. Veuillez tous les renseigner pour avoir accès aux entrées
  comptables générées.
  </p>
  {% else %}
  <pre><code>
  {{ object.accounting_entries }}
  </code></pre>
  {% endif %}
</section>
{% endif %}

<section>
  <legend>Métadonnées</legend>
  <table style="text-align: revert;">
    <thead>
      <th style="text-align: right;">Crée à</th>
      <th>Crée par</th>
      <th>Dernière modification à</th>
      <th>Dernière modification par</th>
    </thead>
    <tbody>
      <tr>
        <td style="text-align: right;">{{ object.created }}</td>
        <td>{{ object.created_by }}</td>
        <td>{{ object.modified }}</td>
        <td>{{ object.modified_by }}</td>
      </tr>
    </tbody>
  </table>
</section>

{% include "log_entries.html" %}
</form>
{% endblock %}

backend/expense_report/templates/expense_report_list.html
{% extends "base.html" %}

{% block content %}
<h3>Toutes les notes de frais</h3>
<div style="vertical-align: middle; display: inline;">
  {% if "all" in request.GET %}
    <a href="{% url "expense-report-list" %}" style="float-right"><button>Notes de frais en cours</button></a>
    <spacer type="vertical" align="center" />
    <button disabled>Toutes les notes de frais</button disabled>
  {% else %}
    <button disabled>Notes de frais en cours</button disabled>
    <spacer type="vertical" align="center" />
    <a href="{% url "expense-report-list" %}?all" style="float-right"><button>Toutes les notes de frais</button></a>
  {% endif %}
</div>
<table>
  <thead>
    <tr>
      <th>ID</th>
      <th>Status</th>
      <th>Date</th>
      <th>Créé par</th>
      <th>Événement</th>
      <th>Descriptif</th>
      <th>Montant</th>
    </tr>
  </thead>
  <tbody>
    {% for object in object_list %}
    <tr>
      <td>{% if object.document_id %}{{ object.document_id }}{% endif %}</td>
      <td class="{% if not object.created_by.banking_information.validated %}text-warning{% endif %}">{{ object.get_state_display }}</td>
      <td>{% if object.submitted_at %}{{ object.submitted_at.date }}{% else %}{{ object.created.date }}{% endif %}</td>
      <td>
        {% if object.created_by %}
        <a href="{% url "user-banking-information-detail" object.created_by.banking_information.pk %}">{{ object.created_by }}</a>
        {% else %}
        Supprimé
        {% endif %}
      </td>
      <td class="text-wrap">
        <a href="{% url "expense-report-detail" object.pk %}">{{ object.get_event_display }} : {{ object.event_description }}</a>
      </td>
      <td class="text-wrap">{{ object.description }}</td>
      <td>{{ object.amount }} €</td>
    </tr>
    {% endfor %}
  </tbody>
</table>
{% endblock %}

backend/expense_report/templates/index.html
{% extends "base.html" %}

{% block content %}
<h3>Mes notes de frais</h3>
<div style="vertical-align: middle; display: inline;">
  {% if "all" in request.GET %}
    <a href="{% url "index" %}" style="float-right"><button>Mes notes de frais en cours</button></a>
    <spacer type="vertical" align="center" />
    <button disabled>Toutes mes notes de frais</button>
  {% else %}
    <button disabled>Mes notes de frais en cours</button>
    <spacer type="vertical" align="center" />
    <a href="{% url "index" %}?all" style="float-right"><button>Toutes mes notes de frais</button></a>
  {% endif %}
</div>
<table>
  <thead>
    <tr>
      <th>ID</th>
      <th>Date</th>
      <th>Status</th>
      <th>Événement</th>
      <th>Descriptif</th>
      <th>Montant</th>
    </tr>
  </thead>
  <tbody>
    {% for object in object_list %}
    <tr>
      <td>{% if object.document_id %}{{ object.document_id }}{% endif %}</td>
      <td>{% if object.submitted_at %}{{ object.submitted_at.date }}{% else %}{{ object.created.date }}{% endif %}</td>
      <td>{{ object.get_state_display }}</td>
      <td class="text-wrap"><a href="{% url "expense-report-detail" object.pk %}">{{ object.get_event_display }} : {{ object.event_description }}</a></td>
      <td class="text-wrap">{{ object.description }}</td>
      <td>{{ object.amount }} €</td>
    </tr>
    {% endfor %}
  </tbody>
</table>
{% endblock %}

backend/expense_report/templates/log_entries.html
<section>
  <legend>Historique des modifications</legend>
  <table style="text-align: revert;">
    <thead>
      <th style="text-align: right;">Horodatage</th>
      <th>Utilisateur</th>
      <th>Resource</th>
      <th>Action</th>
      <th>Changements</th>
    </thead>
    <tbody>
      {% for entry in log_entries %}
      <tr>
        <td style="text-align: right;">{{ entry.timestamp }}</td>
        <td>{{ entry.actor }}</td>
        <td>{{ entry.object_repr }}</td>
        <td>{{ entry.get_action_display }}</td>
        <td>
          <details class="card">
            <summary>...</summary>
            <table style="text-align: revert;">
              <thead>
                <td style="text-align: right;">Champ</td>
                <td>Depuis</td>
                <td>Vers</td>
              </thead>
              <tbody>
                {% for field, values in entry.changes_display_dict.items %}
                <tr>
                  <td style="text-align: right;">{{ field }}</td>
                  <td>{{ values.0 }}</td>
                  <td>{{ values.1 }}</td>
                </tr>
                {% endfor %}
              </tbody>
            </table>
          </details>
        </td>
      </tr>
      {% endfor %}
    </tbody>
  </table>
</section>